#include "../include/config.hpp"
#include "../include/blender.hpp"
#include "../include/vector_parser.hpp"
#include "../include/return_heap_parser.hpp"
#include "../include/SceneParser.hpp"

namespace MQO {

using phoenix::bind;
using phoenix::arg1;
using phoenix::static_cast_;

struct SceneParserImpl
{
	typedef boost::shared_ptr<void> pointer_t;
/*	typedef boost::array<double,3> vector_t;
	typedef stored_rule< scanner_t, parser_context<pointer_t> > property_rule;
	typedef std::pair< int, property_rule > kr;
	
	struct property_closure
		:closure<property_closure, int, property_rule::alias_t>
	{
		member1 key;
		member2 target_p;
	};
	
	enum{
		Position, Lookat, Head, Pitch, Ortho, Pers, Zoom, Ambient
	};
	typedef void result_type;
	symbols< kr > property_p;
	rule<scanner_t, property_closure::context_t > scene_p;
*/
	rule<scanner_t> scene_p;

	SceneParserImpl()
	{
/*		property_p.add
			("pos",		kr( Position,heap_p(vector_p<3>( real_p ))))
			("lookat",	kr( Lookat,heap_p( vector_p<3>( real_p ))))
			("head",	kr( Head, heap_p(real_p)))
			("pich",	kr( Pitch,heap_p(real_p)))
			("ortho",	kr( Ortho,heap_p(real_p)))
			("pers",	kr( Pers,heap_p(real_p)))
			("zoom",	kr( Zoom,heap_p(real_p)))
			("zoom2",	kr( Zoom,heap_p(real_p)))
			("amb",		kr( Ambient,heap_p( vector_p<3>( real_p ))))
		;*/

		scene_p = str_p("Scene") >> ch_p('{') >> *( ~ch_p('}') ) >> ch_p('}');
/*				property_p
				[
					scene_p.key = bind(&kr::first)(static_cast_<kr&>(arg1)),
					scene_p.target_p = bind(&kr::second)(static_cast_<kr&>(arg1))
				]
				>> lazy_p(scene_p.target_p)
					[
						bind(*this)( scene_p.key, arg1 )
					]
			)
			>> ch_p('}')*/
		;
	}

	void parse( scanner_t const &scan )
	{
		scene_p.parse(scan);
	}

	void operator()( int key, pointer_t const &val )
	{

	}
};


parser_result<SceneParser,scanner_t>::type
SceneParser::parse( scanner_t const &scan )const
{
	SceneParserImpl scene_p;
	scanner_t::iterator_t save = scan.first;
	scene_p.parse(scan);

	return scan.first - save > 0 ?
		scan.create_match( scan.first - save, nil_t(), scan.first, scan.first ):
		scan.no_match();
}

}//MQO
